﻿Type=Class
Version=3
@EndOfDesignText@
'Class module
#Event: Click
#Event: LongClick
#Event: ChangeCompleted

Sub Class_Globals

	Type TouchArgs(Action As Int, x As Float, y As Float)

   Private mTarget As Object
   Private mEventName As String
	
	Private pnlTextBack As Panel
	Private pnlTextFore As Panel

	Private mSliceW As Int
	Private mCnvText As Canvas
	Private mRecText As Rect
	Private X_CnvText, Y_CnvText As Float

	Private tmrText As Timer
	
#Region  + MEMBER VARIABLES 
	Private mText As String
	Private mTypeFace1 As Typeface
	Private mTextSize As Int
	Private mAlign1 As String
	Private mTextColor, mNewTextColor As Int
	Private mColor As Int
#End Region

End Sub

Public Sub Initialize (TargetModule As Object, EventName As String)
   mTarget = TargetModule
   mEventName = EventName
	
	mTypeFace1 = Typeface.DEFAULT
	mTextSize = 30
	mAlign1 = "CENTER"
	
	tmrText.Initialize("tmrText", 50) ' TODO interval
	
	' TODO Calculate the mSliceW just for text width
	mSliceW = 2dip

End Sub


Public Sub DesignerCreateView(Base As Panel, Lbl As Label, Props As Map)
	Base.Color = Colors.Transparent
	
	pnlTextBack.Initialize("pnlTextBack")
	Base.AddView(pnlTextBack, 0, 0, Base.Width, Base.Height)
	pnlTextFore.Initialize("pnlTextFore")
	Base.AddView(pnlTextFore, 0, 0, Base.Width, Base.Height)
	pnlTextFore.BringToFront

	mText = Lbl.Text
	mTextSize = Lbl.TextSize
	mTextSize = Lbl.TextSize
	mTypeFace1 = Lbl.Typeface
	mTextColor = Lbl.TextColor
	mNewTextColor = Colors.Yellow

	mRecText.Initialize(0, 0, mSliceW, pnlTextFore.Height)
	
	setColor(Colors.Transparent)
	
End Sub


#Region  + PROPERTIES 

#Region  Text 
Public Sub setText(Text As String)
	mText = Text
	DrawText
End Sub
Public Sub getText As String
	Return mText
End Sub
#End Region

#Region  TextSize 
Public Sub setTextSize(TextSize As Int)
	mTextSize = TextSize
	DrawText
End Sub
Public Sub getTextSize As Int
	Return mTextSize
End Sub
#End Region

#Region  TypeFace1 
Public Sub setTypeFace1(TypeFace1 As Typeface)
	mTypeFace1 = TypeFace1
	DrawText
End Sub
Public Sub getTypeFace1 As Typeface
	Return mTypeFace1
End Sub
#End Region

#Region  Align1 
Public Sub setAlign1(Align1 As String)
	mAlign1 = Align1
	DrawText
End Sub
Public Sub getAlign1 As String
	Return mAlign1
End Sub
#End Region

#Region  Text Color 
Public Sub setTextColor(TextColor As Int)
	mTextColor = TextColor
	DrawText
End Sub
Public Sub getTextColor As Int
	Return mTextColor
End Sub
#End Region

#Region  New Text Color 
Public Sub setNewTextColor(NewTextColor As Int)
	mNewTextColor = NewTextColor
	DrawText
End Sub
Public Sub getNewTextColor As Int
	Return mNewTextColor
End Sub
#End Region

#Region  Color 
Public Sub setColor(Color As Int)
	mColor = Color
	DrawText
End Sub
Public Sub getColor As Int
	Return mColor
End Sub
#End Region



Public Sub GetPanel As Panel
	Return pnlTextBack
End Sub

#End Region


#Region  + PUBLIC METHODS 

Public Sub StartChange
	mRecText.Left = 0
	pnlTextFore.Visible = True
	tmrText.Enabled = True
End Sub

#End Region


#Region  + RAISED EVENTS 

Private Sub ChangeCompleted
	If SubExists(mTarget, mEventName & "_ChangeCompleted") Then
		CallSub(mTarget, mEventName & "_ChangeCompleted")
	End If
End Sub

Private Sub pnlTextBack_Click
	If SubExists(mTarget, mEventName & "_Click") Then
		CallSub(mTarget, mEventName & "_Click")
	End If
End Sub

Private Sub pnlTextBack_LongClick
	If SubExists(mTarget, mEventName & "_LongClick") Then
		CallSub(mTarget, mEventName & "_LongClick")
	End If
End Sub

#End Region

	
#Region  + PRIVATE METHODS 

Private Sub DrawText
Log("pnlTextFore w,h: " & pnlTextFore.Width & "," & pnlTextFore.Height)
Log("pnlTextBack w,h: " & pnlTextBack.Width & "," & pnlTextBack.Height)
	X_CnvText = 50 : Y_CnvText = 50

	mCnvText.Initialize(pnlTextBack)
	mCnvText.DrawText(mText, X_CnvText, Y_CnvText, mTypeFace1, mTextSize, mTextColor, mAlign1)

	mCnvText.Initialize(pnlTextFore)
	mCnvText.DrawText(mText, X_CnvText, Y_CnvText, mTypeFace1, mTextSize, mNewTextColor, mAlign1)
End Sub

#End Region


#Region  + EVENTS 

Sub tmrText_Tick
	mCnvText.DrawRect(mRecText, Colors.Transparent, True, 0)
	pnlTextFore.Invalidate
	DoEvents
	mRecText.Left = mRecText.Left + mSliceW
	If mRecText.Left >= pnlTextFore.Width Then
		tmrText.Enabled = False
		pnlTextFore.Visible = False
		ChangeCompleted
		DrawText
	End If
End Sub

#End Region